

func_sie=function(t, x, vparameters){
      S = x[1]  
      I = x[2]  
      E = x[3]  

      with(as.list(vparameters),{

      dS=  -beta*S*I + gamma*I - theta*S*E
      dI = beta*S*I - gamma*I + theta*S*E  
      dE = eta*I - mu*E                  
      vout = c(dS,dI,dE)
      list(vout)
   })
}



library(lhs)
library("deSolve")
library("sfsmisc")
#source("func_sie")  # you don't need this as you defined the function above

tbegin = 0
tend   = 10000
vt = seq(tbegin,tend,1)  
gamma = 0.017       
theta=0.004
eta=0.013

##################################################################################
# Let's set up some initial conditions at time t=0
# npop is the population
# I_0 is the inital number infected and infectious
# R_0 is the initial number recovered and immune
# S_0 is the initial number susceptible.  Note that npop=S_0+I_0+R_0
##################################################################################
npop = 1000
I_0 = 0
E_0 = 1
S_0 = npop-I_0


cubes_beta=10
pre_beta<-randomLHS(cubes_beta,1)
beta1<-runif(pre_beta, 0.0000012, 0.00001724)

# I would do 10 cubes in desired range by LHS for mu1

cubes_mu=10
set.seed(121)
mu1<-sample(1:40,cubes_mu, replace=FALSE)
# use combn function like our previous code to give you the combinations as well - not correct definition of n combinations

combos<-combn(cbind(beta1,mu1),2) # this code will only work if mu1 and beta1 same length, which is why suggest LHS

n_combos<-length(combos)/2 # this code will only work if mu1 and beta1 same length, which is why suggest LHS


results_infected<-matrix(0,( tend + 1),n_combos)

#then do

for (i in 1:n_combos){
	vparameters = c(gamma=gamma,beta=combos[,i][1],theta=theta,eta=eta,mu=combos[,i][2])
    inits = c(S=S_0,I=I_0,E=E_0)
	sie_model = as.data.frame(lsoda(inits, vt,func_sie, vparameters))
	results_infected[,i]<-sie_model$I/npop
}




plot(1,type="n", xlab="days",ylab="Prevalence",xlim=c(0,tend),ylim=c(0,0.23))


abline(h=0.05,col="red")
abline(h=0.096,col="red")



# something like that 
# then to add lines in different colours something like
# set up your plot with no lines on it
# then add horiontal lines for the limits of the confidence interval around prevalence
# then plot each line in differnet colour according to whether it is in or outside lower limit of confidence interval
# using something like

for (e in 1:n_combos){
	if(max(results_infected[,e])< 0.05){
		lines(vt,results_infected[,e],col="blue")
	}
	else if(max(results_infected[,e])> 0.096){
		lines(vt,results_infected[,e],col="blue")
	}
	else {
		lines(vt,results_infected[,e],col="green")
	}

}


